<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container-fluid">
        <h1 class="text-center">Danh sách người dùng đăng ký</h1>
        <button class="btn btn-success mb-2" id="btn-add-user"><i class="fa fa-plus"></i>New user</button>
        <table class="table table-bordered table-hover table-striped" id="user-table">
            <thead> 
                <tr>
                    <th>Id</th>
                    <th>FirstName</th>
                    <th>LastName</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Biến toàn cục để lưu trữ id voucher đang đc update or delete. Mặc định = 0;
    var gUserId = 0;
  
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
  
    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject","customerType","registerStatus","action"];
  
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_ID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTER_STATUS_COL =6;
    const gACTION_COL = 7;

    // Khai báo DataTable & mapping collumns
    var gUserTable = $("#user-table").DataTable({
      columns: [
        { data: gUSER_COLS[gUSER_ID_COL] },
        { data: gUSER_COLS[gFIRST_NAME_COL] },
        { data: gUSER_COLS[gLAST_NAME_COL] },
        { data: gUSER_COLS[gCOUNTRY_COL] },
        { data: gUSER_COLS[gSUBJECT_COL] },
        { data: gUSER_COLS[gCUSTOMER_TYPE_COL] },
        { data: gUSER_COLS[gREGISTER_STATUS_COL] },
        { data: gUSER_COLS[gACTION_COL] },
      ],
      columnDefs: [
        { // định nghĩa lại cột action
          targets: gACTION_COL,
          defaultContent: `
          <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
          <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
        `
        }
      ]
    });
  
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      // thực hiện tải trang
      onPageLoading();
      // 2 - C: gán sự kiện Create - Thêm mới voucher
      $("#btn-add-voucher").on("click", function () {
        onBtnAddNewVoucherClick();
      });
      // 3 - U: gán sự kiện Update - Sửa 1 voucher
      $("#user-table").on("click", ".edit-user", function () {
        onBtnEditUserClick(this);
      });
      // 4 - D: gán sự kiện delete - Xóa 1 voucher
      $("#user-table").on("click", ".delete-user", function () {
        onBtnDeleteUserClick(this);
      });
      // gán sự kiện cho nút Create Voucher (trên modal)
      $("#btn-create-voucher").on("click", function () {
        onBtnCreateVoucherClick();
      });
  
      // gán sự kiện cho nút Update Voucher (trên modal)
      $("#btn-update-voucher").on("click", function () {
        onBtnUpdateVoucherClick();
      });
      // Gán sự kiện cho nút Confirm Delete voucher (trên modal)
      $("#btn-confirm-delete-voucher").on("click", function () {
        onBtnConfirmDeleteVoucherClick();
      });
    });
  
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
      // 1 - R: Read / Load voucher to DataTable
      getAllUsers();
    }
  
    // Hàm xử lý sự kiện khi nút Thêm mới đc click
    function onBtnAddNewVoucherClick() {
      // hiển thị modal trắng lên
      $("#create-voucher-modal").modal("show");
    }
  
    // Hàm xử lý sự kiện khi icon edit user trên bảng đc click
    function onBtnEditUserClick(paramBtnEdit) {
      // lưu thông tin UserID đang được edit vào biến toàn cục
      gUserId = getUserIdFromButton(paramBtnEdit);
      console.log("User ID vừa được ấn insert: " + gUserId);
    //   // load dữ liệu vào các trường dữ liệu trong modal
    //   getVoucherById(gVoucherId);
    }
    // Hàm xử lý sự kiện khi icon delete voucher trên bảng được click
    function onBtnDeleteUserClick(paramBtnDelete){
      "use strict";
      // lưu thông tin userId đang được edit vào biến toàn cục
      gUserId = getUserIdFromButton(paramBtnDelete);
      console.log("User ID vừa được ấn delete: " + gUserId);
    //   // Show modal delete
    //   // hiển thị modal delete lên
    //   $("#delete-confirm-modal").modal("show");
    }
    // hàm xử lý sự kiện create voucher modal click
    function onBtnCreateVoucherClick() {
      // khai báo đối tượng chứa voucher data
      var vVoucherObj = {
        voucherCode: "",
        discount: -1
      };
      // B1: Thu thập dữ liệu
      getCreateVoucherData(vVoucherObj);
      // B2: Validate insert
      var vIsVoucherValidate = validateVoucherData(vVoucherObj);
      if (vIsVoucherValidate) {
        // B3: insert voucher
        $.ajax({
          url: gBASE_URL,
          type: "POST",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vVoucherObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertVoucherSuccess()
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }
  
    // hàm xử lý sự kiện update voucher modal click
    function onBtnUpdateVoucherClick() {
      // khai báo đối tượng chứa voucher data
      var vVoucherObj = {
        "voucherCode": "",
        "discount": -1
      };
      // B1: Thu thập dữ liệu
      getUpdateVoucherData(vVoucherObj);
      // B2: Validate update
      var vIsVoucherValidate = validateVoucherData(vVoucherObj);
      if (vIsVoucherValidate) {
        // B3: update voucher
        $.ajax({
          url: gBASE_URL + gVoucherId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vVoucherObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleUpdateVoucherSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }
    // hàm xử lý sự kiện delete voucher modal click
    function onBtnConfirmDeleteVoucherClick(){
      "use strict";
      $.ajax({
          url: gBASE_URL + gVoucherId,
          type: "DELETE",       
          success: function (paramRes) {
            // B4: xử lý front-end
            handleDeleteVoucherSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách user đăng ký
    function getAllUsers() {
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        success: function (paramUser) {
          console.log(paramUser)
          loadDataToUserTable(paramUser);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load user array to DataTable
     * in: user array
     * out: user table has data
     */
    function loadDataToUserTable(paramUserArr) {

      gUserTable.clear();
      gUserTable.rows.add(paramUserArr);
      gUserTable.draw();
    }
  
    // hàm get voucher by id
    function getVoucherById(paramVoucherId) {
      $.ajax({
        url: gBASE_URL + paramVoucherId,
        type: "GET",
        success: function (paramVoucher) {
          showVoucherDataToModal(paramVoucher);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
      // hiển thị modal lên
      $("#update-voucher-modal").modal("show");
    }
  
    // hàm show voucher obj lên modal
    function showVoucherDataToModal(paramVoucher) {
      $("#input-update-voucher-code").val(paramVoucher.voucherCode);
      $("#input-update-discount").val(paramVoucher.discount);
    }
  
    // hàm thu thập dữ liệu để create voucher
    function getCreateVoucherData(paramVoucherObj) {
      paramVoucherObj.voucherCode = $("#input-create-voucher-code").val().trim();
      paramVoucherObj.discount = parseInt($("#input-create-discount").val());
    }
  
    // hàm thu thập dữ liệu để update voucher
    function getUpdateVoucherData(paramVoucherObj) {
      paramVoucherObj.voucherCode = $("#input-update-voucher-code").val().trim();
      paramVoucherObj.discount = parseInt($("#input-update-discount").val());
    }
  
    // hàm validate data
    function validateVoucherData(paramVoucherObj) {
      if (paramVoucherObj.voucherCode === "") {
        alert("Voucher code cần nhập");
        return false;
      }
      if (isNaN(paramVoucherObj.discount)) {
        alert("Discount cần nhập vào phải là số");
        return false;
      }
  
      if (paramVoucherObj.discount < 0 || paramVoucherObj.discount > 100) {
        alert("Discount phải nhập trong khoảng từ 0 đến 100!");
        return false;
      }
  
      return true;
    }
  
    // hàm xử lý hiển thị front-end khi thêm voucher thành công
    function handleInsertVoucherSuccess() {
      alert("Thêm voucher thành công!");
      getAllVouchers();
      resertCreateVoucherForm();
      $("#create-voucher-modal").modal("hide");
    }
  
    // hàm xử lý hiển thị front-end khi sửa voucher thành công
    function handleUpdateVoucherSuccess() {
      alert("Sửa voucher thành công!");
      getAllVouchers();
      resertUpdateVoucherForm();
      $("#update-voucher-modal").modal("hide");
    }
    // Hàm xử lý hiển thị front-end khi xóa voucher thành công
    function handleDeleteVoucherSuccess(){
      alert("Xóa voucher thành công!");
      getAllVouchers();    
      $("#delete-confirm-modal").modal("hide");
    }
    // hàm xóa trắng form create voucher
    function resertCreateVoucherForm() {
      $("#input-create-voucher-code").val("");
      $("#input-create-discount").val("");
    }
  
    // hàm xóa trắng form update voucher
    function resertUpdateVoucherForm() {
      $("#input-update-voucher-code").val("");
      $("#input-update-discount").val("");
    }
  
    // hàm dựa vào button detail (edit or delete) xác định đc id voucher
    function getUserIdFromButton(paramButton) {
      var vTableRow = $(paramButton).parents("tr");
      var vUserRowData = gUserTable.row(vTableRow).data();
      return vUserRowData.id;
    }
  
  </script>
</html>